﻿#target bridge
if ( BridgeTalk.appName == "bridge" )
//-----------------------------------------------------------------------
//This script copies selected thumbnails' filenames to the title field 
//Also shows how to add menu items
//The AdobeLibrary scripts must be loaded
//This script was created by John Beardsworth www.beardsworth.co.uk
//This script may be freely distributed and modified
//--------------------------------------------------------------------

// Create main menu item
	if (MenuElement.find ('f2mMenu') != null) 
	{
	MenuElement.remove("f2mMenu");
	MenuElement.remove("f2tCommand");
	MenuElement.remove("f2tpCommand");
	MenuElement.remove("f2pCommand");
	MenuElement.remove("f2xCommand");
	MenuElement.remove("f2xtpCommand");
	MenuElement.remove("f2xpCommand");
	MenuElement.remove("f2pcCommand");
	}
	
	var menu = new MenuElement( "menu", "Filename to Metadata", "after BatchRename", "f2mMenu");
	var f2tCommand =  new MenuElement("command", "Title only", "at the end of f2mMenu");
	var f2tpCommand =  new MenuElement("command", "Title and preserved filename", "at the end of f2mMenu");
 	var f2pCommand =  new MenuElement("command", "Preserved filename", "at the end of f2mMenu");
	var f2xCommand = new MenuElement( "command", "Title only (no extension)", "-at the end of f2mMenu"); 
	var f2xtpCommand = new MenuElement( "command", "Title and preserved filename ", "at the end of f2mMenu"); 
	var f2xpCommand = new MenuElement( "command", "Preserved filename ", "at the end of f2mMenu"); 
	var f2pcCommand = new MenuElement( "command", "Clear preserved filename", "-at the end of f2mMenu"); 


//-----------------------------------------------------------------------
//Submenu for filename to iptc title
	f2tCommand.onSelect = function(m) 
		{
		var getFolderChildren = true ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;
		for ( var i = 0; i < thumbs.length; i++ )
		{ var thumb = thumbs[i];
		   var md = thumb.synchronousMetadata;
		   md.namespace ="http://ns.adobe.com/photoshop/1.0/";
		   md.Title = thumb.name;   
		}
		   Window.alert ("Done " + i + " records");
		};  
//-----------------------------------------------------------------------
//Submenu for filename to iptc title and preserved filename 
	f2tpCommand.onSelect = function(m) 
		{
		var getFolderChildren = true ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;
		for ( var i = 0; i < thumbs.length; i++ )
		{ thumb = thumbs[i];
		   md = thumb.synchronousMetadata;
		   md.namespace ="http://ns.adobe.com/photoshop/1.0/";
		   md.Title = thumb.name;   
		   md.namespace ="http://ns.adobe.com/xap/1.0/mm/";
		   md.PreservedFileName = thumb.name;   
		}
		   Window.alert ("Done " + i + " records");
		}; 
//-----------------------------------------------------------------------
//Submenu for filename to iptc title and preserved filename 
	f2pCommand.onSelect = function(m) 
		{
		var getFolderChildren = true ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;
		for ( var i = 0; i < thumbs.length; i++ )
		{ thumb = thumbs[i];
		   md = thumb.synchronousMetadata;
		   md.namespace ="http://ns.adobe.com/xap/1.0/mm/";
		   md.PreservedFileName = thumb.name;   
		}
		   Window.alert ("Done " + i + " records");
		}; 



		
//-----------------------------------------------------------------------
//Submenu for filename to iptc title (no extension)
		f2xCommand .onSelect = function(m) 
		{
		var getFolderChildren = true  ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;

		for ( var i = 0; i < thumbs.length; i++ )
		{ thumb = thumbs[i];
		   md = thumb.synchronousMetadata;
		   md.namespace ="http://ns.adobe.com/photoshop/1.0/";
		   var fileArray = thumb.name.split(".");
		   md.Title = fileArray[0];   
		}
		   Window.alert ("Done " + i + " records");
		}; 
		
		
//-----------------------------------------------------------------------
//Submenu for filename to title and preserved filename 
		f2xtpCommand.onSelect = function(m) 
		{
		var getFolderChildren = true  ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;

		for ( var i = 0; i < thumbs.length; i++ )
		{ thumb = thumbs[i];
		   md = thumb.synchronousMetadata;
		   var fileArray = thumb.name.split(".");
		   md.namespace ="http://ns.adobe.com/photoshop/1.0/";
		   md.Title = fileArray[0];
		   md.namespace ="http://ns.adobe.com/xap/1.0/mm/";
		   md.PreservedFileName = fileArray[0];	   
		}
		   Window.alert ("Done " + i + " records");
		};

//-----------------------------------------------------------------------
//Submenu for filename to preserved filename 
		f2xpCommand.onSelect = function(m) 
		{
		var getFolderChildren = true  ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;

		for ( var i = 0; i < thumbs.length; i++ )
		{ thumb = thumbs[i];
		   md = thumb.synchronousMetadata;
		   var fileArray = thumb.name.split(".");
		   md.namespace ="http://ns.adobe.com/xap/1.0/mm/";
		   md.PreservedFileName = fileArray[0];	   
		}
		   Window.alert ("Done " + i + " records");
		};
		
//-----------------------------------------------------------------------
//Submenu to empty the preserved filename 
		f2pcCommand.onSelect = function(m) 
		{
		var getFolderChildren = true  ;
		var filesOnly = true ;
		var thumbs = getBridgeThumbnails ( TYPES.PHOTOSHOP_OPENABLE, getFolderChildren, filesOnly) ;

		for ( var i = 0; i < thumbs.length; i++ )
		{ thumb = thumbs[i];
		   md = thumb.synchronousMetadata;
		   var fileArray = thumb.name.split(".");
		   md.namespace ="http://ns.adobe.com/xap/1.0/mm/";
		   md.PreservedFileName = "";	   
		}
		   Window.alert ("Done " + i + " records");
		};